﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Table1 As Table
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	Show_Table
End Sub

Private Sub Button1_Click
	'xui.MsgboxAsync("Hello world!", "B4X")
	Create_Excel
	Wait For Create_Excel_Complete
	Wait For (SaveAs(File.OpenInput(File.DirDefaultExternal, "book5.xlsx"), "application/octet-stream", "TestExcel.xlsx")) Complete (Success As Boolean)
	Log("File saved successfully? " & Success)
End Sub

Private Sub Show_Table	
	Table1.SetHeader(Array As String("ID","V1","V2","V3","V4","V5","V6"))
	Table1.SetColumnsWidths(Array As Int(35dip,60dip,60dip,60dip,60dip,60dip,60dip))
	Table1.HeaderAlignment=Bit.Or(Gravity.CENTER_HORIZONTAL,Gravity.CENTER_VERTICAL)
	Table1.HeaderTypeFace=Typeface.DEFAULT_BOLD	
	For i=1 To 10
		Dim row(7) As String
		For j=0 To 6
			row(j)=IIf(j=0,i,$"${i}${j}"$)			
		Next		
		Table1.AddRow(row)
	Next
	'Table1.NumberOfFixedColumns=1
End Sub

Private Sub Create_Excel
	If File.Exists(File.DirInternal,"book1.xlsx")=True Then
		File.Delete(File.DirInternal,"book1.xlsx")
	End If
	File.Copy(File.DirAssets,"book1.xlsx",File.DirInternal,"book1.xlsx")
	Dim wk As XSSFWorkbook	
	wk.Initialize("",File.Combine(File.DirInternal,"book1.xlsx"))
	Dim sheet As XLSSheet=wk.getSheetAt(wk.ActiveSheetIndex)
	Dim row0 As XSSFRow=sheet.getRow(0)
	row0.getCell(0).StringCellValue="TestExcel"
	Dim row1 As XSSFRow=sheet.getRow(1)
	Dim style1 As CellStyle=row1.getCell(1).CellStyle
	Dim row2 As XSSFRow=sheet.getRow(2)
	Dim style2 As CellStyle=row2.getCell(0).CellStyle
	Dim style3 As CellStyle=row2.getCell(1).CellStyle
	For row=3 To Table1.Size+2
		Dim erow As XSSFRow=sheet.createRow(row)
		For col=0 To 6
			Dim cell As XSSFCell=erow.createCell(col)
			cell.StringCellValue=Table1.GetValue(col,row-3)
			cell.CellStyle=IIf(row=3,style1,IIf(col=1 Or col=6,style3,style2))
		Next
	Next
	If File.Exists(File.DirDefaultExternal,"book5.xlsx")=True Then
		File.Delete(File.DirDefaultExternal,"book5.xlsx")
	End If
	wk.write2(File.DirDefaultExternal,"book5.xlsx")
	CallSubDelayed(Me, "Create_Excel_Complete")
End Sub


Sub SaveAs (Source As InputStream, MimeType As String, Title As String) As ResumableSub
	Dim intent As Intent
	intent.Initialize("android.intent.action.CREATE_DOCUMENT", "")
	intent.AddCategory("android.intent.category.OPENABLE")
	intent.PutExtra("android.intent.extra.TITLE", Title)
	intent.SetType(MimeType)
	StartActivityForResult(intent)
	Wait For ion_Event (MethodName As String, Args() As Object)
	If -1 = Args(0) Then 'resultCode = RESULT_OK
		Dim result As Intent = Args(1)
		Dim jo As JavaObject = result
		Dim ctxt As JavaObject
		Dim ContentResolver As JavaObject = ctxt.InitializeContext.RunMethodJO("getContentResolver", Null)
		Dim out As OutputStream = ContentResolver.RunMethod("openOutputStream", Array(jo.RunMethod("getData", Null), "wt")) 'wt = Write+Trim
		File.Copy2(Source, out)
		out.Close
		Return True
	End If
	Return False
End Sub

Sub StartActivityForResult(i As Intent)
	Dim jo As JavaObject = GetBA
	Dim	ion As Object = jo.CreateEvent("anywheresoftware.b4a.IOnActivityResult", "ion", Null)
	jo.RunMethod("startActivityForResult", Array(ion, i))
End Sub

Sub GetBA As Object
	Dim jo As JavaObject = Me
	Return jo.RunMethod("getBA", Null)
End Sub